// =========================================================
// Работа с потоками в оперативной памяти
//
// (C) Фролов А.В, 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            или
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;
import java.io.*;

public class MemStream extends Applet
{
  // Выходной поток
  DataOutputStream OutStream;

  // Входной поток
  DataInputStream  InStream;

  // Строка, которая будет записана в поток
  String sOut;

  // Массив, в который будет копироваться содержимое
  // выходного потока
  byte[] bMemStream;

	// -------------------------------------------------------
  // getAppletInfo
  // Метод, возвращающей строку информации об аплете
  // -------------------------------------------------------
  public String getAppletInfo()
	{
		return "Name: MemStream\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

  // -------------------------------------------------------
  // init
  // Метод init, получает управление при инициализации аплета
  // -------------------------------------------------------
	public void init()
	{
    // Инициализируем строку для записи в поток
    sOut = "Hello, Java!";

    try
    {
      // Создаем выходной поток в оперативной памяти
      ByteArrayOutputStream baStream = 
        new ByteArrayOutputStream(255);

      // Создаем буферизованный форматированный поток
      // на базе потока baStream 
      OutStream = new DataOutputStream(
        new BufferedOutputStream(baStream));

      // Записываем строку sOut в выходной поток
      OutStream.writeBytes(sOut);

      // Сбрасываем содержимое буфера
      OutStream.flush();

      // Копируем содержимое потока в массив bMemStream 
      bMemStream = baStream.toByteArray();

      // Закрываем выходной поток
      OutStream.close();
    }
    catch(Exception ioe)
    {
    }
  }

  // -------------------------------------------------------
  // paint
  // Метод paint, выполняющий рисование в окне аплета
  // -------------------------------------------------------
	public void paint(Graphics g)
	{
    // Определяем текущие размеры окна аплета
    Dimension dimAppWndDimension = size();
    
    // Выбираем в контекст отображения желтый цвет
    g.setColor(Color.yellow);
    
    // Закрашиваем внутреннюю область окна аплета
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    // Выбираем в контекст отображения черный цвет
    g.setColor(Color.black);

    // Рисуем рамку вокруг окна аплета
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    try
    {
      // Создаем входной буферизованный поток данных
      InStream = new DataInputStream(
        new BufferedInputStream(
        new ByteArrayInputStream(bMemStream)));

      // Читаем одну строку из созданного входного потока
      // и отображаем ее
      g.drawString(InStream.readLine(), 10, 20);

      // Закрываем входной поток
      InStream.close();
    }
    catch(Exception ioe)
    {
    }
	}
}
